SystemOrganization addCategory: #'ObjectIndexer-Core'!
SystemOrganization addCategory: #'ObjectIndexer-Core-Tests'!
SystemOrganization addCategory: #'ObjectIndexer-ScouchDB'!

SortedCollection subclass: #OIDeletedResults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIDeletedResults class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 11:31'!
new
^ self sortBlock:[:a :b| (a id) < (b id)].! !

!OIDeletedResults methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 12:58'!
fromJson:aJsonObject

aJsonObject do:[:anItem|
	self add: (OIDeletedResult new fromJson: anItem)
	]! !

!OIDeletedResults methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 12:07'!
includes:anItem
"fast version of includes..."
|i|

i:=self indexForInserting:anItem.
(i> array size) ifTrue:[^ false].
^((array at: i)= anItem)! !

!OIDeletedResults methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 10:43'!
remove:anItem
"fast version of remove...it doe'nt reorder the collection just dupplicates the element before"
|i|
i:=self indexForInserting:anItem.
((i <= self size ) and:[
((self at:i)= anItem)])
	ifTrue:[	^self removeAt:i]
	ifFalse:[ ^nil].! !

TestCase subclass: #OIThesaurusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core-Tests'!

OIThesaurusTest class
	instanceVariableNames: 'oi'!

OIThesaurusTest class
	instanceVariableNames: 'oi'!

!OIThesaurusTest class methodsFor: 'accessing' stamp: 'JesusMari 5/21/2013 18:45'!
oi
	^ oi! !

!OIThesaurusTest class methodsFor: 'accessing' stamp: 'JesusMari 5/21/2013 18:45'!
oi: anObject
	oi := anObject! !

!OIThesaurusTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/12/2013 12:24'!
testThesaurus
|str text1 words3 words2 words1 |

OIThesaurusTest oi ifNil:[OIThesaurusTest oi: ( OIThesaurus on:'thesaurus\mobythes.csv')].

OIThesaurusTest oi explore.
 
str:=StandardFileStream readOnlyFileNamed:'\rfc1000\rfc1.txt'.
text1:=str contents.
words2:= Set new.
words3:=Set new.
words1:= text1 findTokens: Character space.
words1 do:[:aWord|
	
	Transcript show: (words3 add:aWord).
	Transcript show: '-'.
	 Transcript show: (words2 add: (OIThesaurusTest oi getSynonymousOf: aWord)).
	Transcript cr].

self assert: (words2 size<= words3 size).
	Transcript show: words2 size asString,'<= ',words3 size asString.! !

TestCase subclass: #OIndexerTest
	instanceVariableNames: 'indexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core-Tests'!

!OIndexerTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:35'!
getEmptyIndexer
| ob |
"indexe four string object indexed by its value"
indexer := OIndexer on:'objectIndexer-empty-test'.

^indexer
! !

!OIndexerTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/27/2013 17:31'!
getIndexer
| ob |
indexer ifNil:[
	"indexe four string object indexed by its value"
	ob:=Array with:'hello .hello world' with:'hello' with:'are' with:'you'.
	indexer := OIndexer on:'objectIndexer-test'.
	indexer indexeMessages: (Array with:#asString) by: #asString  fromACollection: ob.
	].
^indexer
! !

!OIndexerTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/4/2013 09:33'!
getRFCIndexer
| ob |
"indexe four string object indexed by its value"
indexer := OIndexer on:'objectIndexer-rfc-test'.

^indexer
! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 5/1/2013 12:27'!
testIndexeADir
	| oi result ob|
	
	
	oi := self getEmptyIndexer.
	oi indexeFolder:'D:\smalltalk\SCouchViewServer\templates'.

	! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 5/4/2013 12:59'!
testIndexeRFCADir
	| oi result ob|
	
	
	oi := self getRFCIndexer.
	oi indexeFolder:'D:\smalltalk\SCouchViewServer\rfc'.
	oi inspect.

	! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 5/2/2013 10:26'!
testLongFile
	| oi result ob|
	
	
	oi := self getEmptyIndexer.
	result:= oi findPhrase:  'requires specific title' minTarget: 0.6.
	self halt.
! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 3/17/2013 16:08'!
testLongFile2
	| oi result ob|
	
	
	oi := self getEmptyIndexer.

	result:= oi findPhrase:  'name function' minTarget: 1.
	self assert:  ((result at:1) key ='jquerycouch') .
	result:= oi findPhrase:  'object to an url query string' minTarget: 1.
	self assert:  ((result at:1) key ='jquerycouch') .! !

!OIndexerTest methodsFor: 'tests' stamp: 'JesusMari 5/1/2013 10:56'!
testVariousResults
	| oi result ob|
	
	
	oi := self getIndexer.
	
	result:= oi findPhrase:  'hello' minTarget: 3/4.

	self assert:  ((result at:1) value = 1.0) .
	"self assert:  ((result at:2) value = 1.0) ."

	result:= oi findPhrase:  'world hello ' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	"self assert:  ((result at:1) value =0.8611111111111112 ) ."
	
	result:= oi findPhrase:  'hello world' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	"self assert:  ((result at:1) value =1) ."

	result:= oi findPhrase:  'hello world Jesus' minTarget: 0.5.
	self assert:  ((result at:1) key = 'hello .hello world') .
	"self assert:  ((result at:1) value =0.6666666666666666) ."
	

	result:= oi findPhrase:  'hell' minTarget: 1.
"	self assert:  ((result at:1) key = 'hello .hello world') .
	self assert:  ((result at:1) value = 1.0) ."
	! !

!SCouchDBAppWrapper methodsFor: '*objectIndexer-scouchdb-validate' stamp: 'JesusMari 1/12/2013 13:41'!
indexerAt: anIndexerPath

^self validate indexerAt: (anIndexerPath).! !

!SCouchDBValidate methodsFor: '*objectIndexer-scouchdb' stamp: 'JesusMari 9/12/2013 18:51'!
indexerAt:aRelativePath
|a|
a:= indexers 
ifNil:[
	indexers:= JsonObject new. 
	indexers at:aRelativePath put:(OIFolderIndexer name:aRelativePath)
	] 
ifNotNil:[
	indexers at:aRelativePath ifAbsentPut:[OIFolderIndexer name:aRelativePath]].

^a! !

Object subclass: #OIDeletedResult
	instanceVariableNames: 'id timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIDeletedResult class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 11:25'!
id:anId
|a|
a:=super new.
a id:anId.
a timestamp:Time millisecondClockValue.
^a
! !

!OIDeletedResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 11:04'!
= anOIResult
^ (self id = anOIResult id) and:[self timestamp > anOIResult timestamp]

! !

!OIDeletedResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 12:58'!
fromJson:anArray
self id:(anArray at:1).
self timestamp: (anArray at:2).
! !

!OIDeletedResult methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 11:00'!
id
	^ id! !

!OIDeletedResult methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 11:00'!
id: anObject
	id := anObject! !

!OIDeletedResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 12:11'!
jsonWriteOn:aStream
(Array with:self id with:self timestamp)  jsonWriteOn:aStream! !

!OIDeletedResult methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 11:00'!
timestamp
	^ timestamp! !

!OIDeletedResult methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 11:00'!
timestamp: anObject
	timestamp := anObject! !

Object subclass: #OIResult
	instanceVariableNames: 'id pos timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIResult class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2013 01:46'!
id:anID pos:pos 
|i|
i:=  self new.
i id:anID.
i pos:pos.
i timestamp: Time millisecondClockValue .
^i
! !

!OIResult class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 09:52'!
id:anID pos:pos timestamp:timeInms
|i|
i:=  self new.
i id:anID.
i pos:pos.
i timestamp: timeInms.
^i
! !

!OIResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 11:21'!
= aDeletedResult

^(self id = aDeletedResult id) and:[self timestamp < aDeletedResult timestamp]! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
id
	^ id! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
id: anObject
	id := anObject! !

!OIResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2013 00:57'!
jsonWriteOn:aStream
(Array with:self id with: self pos with:self timestamp)  jsonWriteOn:aStream! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
pos
	^ pos! !

!OIResult methodsFor: 'accessing' stamp: 'JesusMari 12/27/2012 16:04'!
pos: anObject
	pos := anObject! !

!OIResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2013 00:57'!
timestamp
^timestamp! !

!OIResult methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2013 00:56'!
timestamp:time
timestamp:=time! !

Object subclass: #OIReverseNode
	instanceVariableNames: 'identifierCollection dictionary parent path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

OIReverseNode subclass: #OIFsReverseNode
	instanceVariableNames: 'fd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIFsReverseNode class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/30/2013 11:21'!
on:aPath
| ins files node|
ins:=super on:aPath.

files:=ins rootNode fd fileNamesMatching: '*.json'.
files do: [:fn|
	node:= fn findTokens: $..
	(ins nodeAt: (node at:1))
	].
^ins! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2013 01:38'!
fd

fd ifNil:[fd:=FileDirectory new directoryNamed:self fullPath].
^fd ! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/24/2013 09:08'!
fd: aFileDirectory
fd := aFileDirectory! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/23/2013 22:03'!
filename
^ '_', self path, '.json'! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 10:06'!
fromJson:aJsonObject
| n |
self reset.
(aJsonObject at:'subnodes') ifNotNil:[
	(aJsonObject at:'subnodes') do: [:sn|
		n:=self nodeAt: sn path.
		n fromJson: sn
		]
].
(aJsonObject at:'identifiers') ifNotNil:[
	(aJsonObject at:'identifiers') do: [:id|
		self addIdentifier: (id at:1) atPos: (id at:2) timestamp:(id at:3)
		]
	]! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/30/2013 09:52'!
jsonWriteOn: aStream
aStream nextPut: ${.
aStream nextPutAll: '"path":"',self path,'"'.
dictionary ifNotNil:[aStream nextPutAll: ', "subnodes":'.
self dictionary jsonWriteOn:aStream].
identifierCollection ifNotNil:[
	aStream nextPutAll: ', "identifiers":'.
	self identifiers jsonWriteOn:aStream].
aStream nextPut: $}.

self parent ifNotNil:[self parent isRoot ifTrue:[aStream nextPutAll: String crlf.]]! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/30/2013 12:57'!
load:aFilename
|stream result collection jobject |

stream:=  (self rootNode fd fileNamed: aFilename).
[
	[stream atEnd] whileFalse:[
		jobject:= (Json readFrom: (ReadStream on:(stream nextLine asString))).
		self fromJson:jobject.
		]
]
ensure:[stream close].
fd:=nil.! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/30/2013 11:04'!
reset
	super reset.
	self fd:nil.! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/23/2013 22:06'!
snapshot 
|subdirs sd stream|
	sd:=self rootNode fd assureExistence.

	stream:=sd fileNamed: self filename.
		[Json render:self on:stream "identifiers" ] ensure: [stream close].
	"once it is saved remove from memory, we do not want it for so long"
	self reset.
	Transcript show:'.'! !

!OIFsReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/23/2013 22:03'!
startUp
|files|
files:=self rootNode fd fileNamesMatching: self filename.
files isEmpty ifFalse: [
	(self load:files asSortedCollection last)
	].
! !

!OIReverseNode class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/18/2013 00:11'!
on:aPath
|a|
a:=self new.
a path:  aPath.
^a 
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/24/2013 09:11'!
addIdentifier: anObject atPos:anInteger 
	self identifiers	add: (OIResult id:anObject pos:anInteger ).
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 10:06'!
addIdentifier: anObject atPos:anInteger timestamp: timeInms
	self identifiers	add: (OIResult id:anObject pos:anInteger timestamp:timeInms).
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/21/2013 09:34'!
at:anObject ifAbsent:block
"returns the object in this current node, if absent executes the block"
| a|
a:=self dictionary at:anObject ifAbsent:block.
^a

! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/6/2013 11:13'!
dictionary

dictionary ifNil:[dictionary:=Dictionary new].
^dictionary! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/30/2013 10:02'!
dictionary:aDictionary

dictionary:=aDictionary.
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/31/2013 09:57'!
firstNode
|myPath previousNode  t |
"first child node down the root"
myPath:= String new.
t:=self.
previousNode:= self parent.
[previousNode parent isNil] whileFalse:[
	t:=previousNode.
	previousNode:= previousNode parent.
	].
^t! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/31/2013 09:58'!
fullPath
|myPath previousNode par t |

myPath:= self path.
par:=self.
previousNode:= self parent.

[previousNode  isNil] whileFalse:[
	par parent ifNotNil:[myPath:=  previousNode path , FileDirectory pathNameDelimiter asString ,myPath].
	t:=previousNode.
	previousNode:= previousNode parent.
	par:=t
	].
^myPath! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/18/2013 03:04'!
identifiers
	identifierCollection ifNil:[identifierCollection:=OrderedCollection new].
	^ identifierCollection! !

!OIReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/24/2013 20:51'!
isRoot
^self parent isNil! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/24/2013 09:11'!
nodeAt:anObject 
"adds an index node to the path dictionary...when you call snapshot then it saves the identifierCollection in its corresponding node(path)
returns the node at a path"
| n a|

	n:=self trulyAssureExistenceOfPath: anObject.
^n

! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:43'!
parent
	^ parent! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:43'!
parent: anObject
	parent := anObject! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:59'!
path
^path! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:59'!
path:aPath
path:=aPath
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/18/2013 22:24'!
relativePath
|myPath previousNode |

myPath:= self path.
previousNode:= self parent.
previousNode ifNil:[^ ''].
[previousNode  parent isNil] whileFalse:[
	myPath:= previousNode path  , FileDirectory pathNameDelimiter asString ,'%', myPath.
	previousNode:= previousNode parent.
	].
^'%',myPath! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/30/2013 10:58'!
reload
(dictionary isNil and: [identifierCollection isNil]) ifTrue:[self startUp].
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/6/2013 10:58'!
removeIdentifier: anId

	self identifiers removeAllSuchThat: [:aResult| (aResult id= anId) ].

	! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/30/2013 11:04'!
reset
	identifierCollection:=nil.
	dictionary:=nil.
! !

!OIReverseNode methodsFor: 'accessing' stamp: 'JesusMari 5/31/2013 09:56'!
rootNode
|myPath previousNode  t |
"root node in the tree"
myPath:= String new.
t:=self.
previousNode:= self parent.
[previousNode isNil] whileFalse:[
	t:=previousNode.
	previousNode:= previousNode parent.
	].
^t! !

!OIReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/24/2013 09:10'!
snapshot
self subclassResponsibility ! !

!OIReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/24/2013 09:10'!
startUp
self subclassResponsibility ! !

!OIReverseNode methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/15/2013 10:29'!
trulyAssureExistenceOfPath: anObject
|subdirs sd par|

	subdirs:= anObject asString findTokens: FileDirectory pathNameDelimiter.
	sd:=self.
	subdirs do:[:aDir|
		par:=sd.
		sd:=sd dictionary at:aDir ifAbsentPut:[self class new].
		sd parent:par.
		sd path:aDir
	].
	^ sd.
! !

Object subclass: #OIThesaurus
	instanceVariableNames: 'mainIndex indexName process numberOfWords stopWords'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

OIThesaurus class
	instanceVariableNames: 'stop'!

OIThesaurus class
	instanceVariableNames: 'stop'!

!OIThesaurus class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/10/2013 19:23'!
on2: aDirName
| a |
a:= self new.
a numberOfWords:0.
a process:([a buildThesaurusIIFrom:FileDirectory default pathName, FileDirectory pathNameDelimiter asString, aDirName asString] forkNamed: 'Building-Thesaurus').
a mainIndex path:FileDirectory default pathName.
^a! !

!OIThesaurus class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/30/2013 15:38'!
on: aDirName
| a |
a:= self new.
a numberOfWords:0.
a process:([a buildThesaurusFrom:FileDirectory default pathName, FileDirectory pathNameDelimiter asString, aDirName asString] forkNamed: 'Building-Thesaurus').
a mainIndex path:FileDirectory default pathName.
^a! !

!OIThesaurus methodsFor: 'initialize-release' stamp: 'JesusMari 9/10/2013 20:10'!
buildThesaurusFrom: aThesaurusFile
|aLine stream words i j|
"reads a CSV thesaurus file where the first worl is the key, followed by sinonimous"
stream:=StandardFileStream readOnlyFileNamed: aThesaurusFile.
j:=1.
[stream atEnd] whileFalse:[
	aLine:= stream nextLine.
	
	words:=aLine findTokens: $,.
	((words first indexOf: Character space)= 0) ifTrue:[
		((words first) > ( words at:2))
		ifTrue:[	
				i:=2.
				[(i <= words size) or:[(((words at:i) indexOf: Character space)= 0)]]
				whileFalse:[	i:=i+1].
				i<=words size ifTrue:[self indexeAWord: words first asLowercase  sinonimous: (words at:i ) asLowercase ]].
	]
]! !

!OIThesaurus methodsFor: 'initialize-release' stamp: 'JesusMari 9/10/2013 20:09'!
buildThesaurusIIFrom: aThesaurusFile
|aLine stream words i j|
"reads a CSV thesaurus file where the first worl is the key, followed by sinonimous"
stream:=StandardFileStream readOnlyFileNamed: aThesaurusFile.
j:=1.
[stream atEnd] whileFalse:[
	aLine:= stream nextLine.	
	words:=aLine findTokens: $,.
	i:=1.
	
	[(i <= words size) or:[(((words at:i) indexOf: Character space)= 0)]] whileFalse:[	i:=i+1].
	i<=words size ifTrue:[
		words do:[:aWord|
			self indexeAWord: aWord asLowercase  sinonimous: (words at:i ) asLowercase ]
		]
].
	
! !

!OIThesaurus methodsFor: 'private' stamp: 'JesusMari 6/18/2013 13:31'!
clean: aWord

^(aWord collect:[:c | 
	
	(c isLetter or: [c = Character space or: [c isDigit ] ]) 
	ifTrue:[c] 
	ifFalse:[
		(c=$' or:[c=$]) ifTrue:[$%]
		ifFalse:[Character space]]] ) asLowercase ! !

!OIThesaurus methodsFor: 'private' stamp: 'JesusMari 5/10/2013 19:37'!
delimiters
^ Character space! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 5/10/2013 19:37'!
getPathTo:aWord
"returns the pathname to a word"
|i strm|

strm:= ReadWriteStream on:String new.
i:= 1.
[i<=aWord size]  whileTrue:[
		"jump consonants"	.
		[(i> aWord size) or:[(aWord at:i) isVowel "or:[(aWord at:i)= $y]"]] whileFalse:[strm nextPut: (aWord at:i). i:=i+1].
		"jump vowels"
		[(i<= aWord size) and:[(aWord at:i) isVowel "or:[(aWord at:i)= $y]" ]] whileTrue:[strm nextPut: (aWord at:i). i:=i+1].
	"double consonant? one for the previous syllabe"
		"((i+1 <= aWord size) and:[((aWord at:i+1) isVowel or:[(aWord at:i)= $y]) not ]) ifTrue:[strm nextPut: (aWord at:i). i:=i+1].	
		((i = aWord size) and:[((aWord at:i) isVowel  or:[(aWord at:i)= $y]) not ]) ifTrue:[strm nextPut: (aWord at:i). i:=i+1].	"
		"strm nextPut: $% ."
		strm nextPut:FileDirectory pathNameDelimiter.
		].
^strm! !

!OIThesaurus methodsFor: 'private-querying' stamp: 'JesusMari 5/19/2013 01:46'!
getSynonymousOf:aWord
| treeNode   syllabes  |


syllabes:= (((self getPathTo: aWord) contents) findTokens: FileDirectory pathNameDelimiter).

treeNode:=mainIndex.
syllabes do: [:aSyllabe|
		 treeNode:=treeNode at: aSyllabe ifAbsent:[ 	^ aWord].
].


treeNode identifiers isEmpty  ifTrue:[^aWord] ifFalse:[^treeNode identifiers first]
! !

!OIThesaurus methodsFor: 'private-indexing' stamp: 'JesusMari 5/30/2013 16:02'!
indexeAWord:aWord sinonimous:aSyn
| treeNode root rn strm|

	treeNode:=mainIndex.
	strm:= self getPathTo: (self clean:aWord) .
	treeNode:= self mainIndex  nodeAt: strm contents.
	treeNode identifiers add: (self clean:aSyn).
	numberOfWords:=numberOfWords +1. 
	^treeNode.
! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 9/12/2013 12:09'!
isLoaded

^ process isTerminated.! !

!OIThesaurus methodsFor: 'private' stamp: 'JesusMari 5/24/2013 09:06'!
mainIndex
^mainIndex ifNil:[mainIndex:=OIReverseNode new]! !

!OIThesaurus methodsFor: 'private' stamp: 'JesusMari 5/10/2013 19:37'!
minSize
^3! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 5/30/2013 16:01'!
numberOfWords
	^ numberOfWords! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 5/30/2013 16:02'!
numberOfWords: anObject
	numberOfWords := anObject! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 5/21/2013 18:23'!
process
	^ process! !

!OIThesaurus methodsFor: 'accessing' stamp: 'JesusMari 5/21/2013 18:23'!
process: anObject
	process := anObject! !

!OIThesaurus methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/11/2013 13:14'!
stopWordsES

^ stopWords ifNil:[
	
	stopWords:= 'algn
alguna
algunas
alguno
algunos
ambos
ampleamos
ante
antes
aquel
aquellas
aquellos
aqui
arriba
atras
bajo
bastante
bien
cada
cierta
ciertas
cierto
ciertos
como
con
conseguimos
conseguir
consigo
consigue
consiguen
consigues
cual
cuando
dentro
desde
donde
dos
el
ellas
ellos
empleais
emplean
emplear
empleas
empleo
en
encima
entonces
entre
era
eramos
eran
eras
eres
es
esta
estaba
estado
estais
estamos
estan
estoy
fin
fue
fueron
fui
fuimos
gueno
ha
hace
haceis
hacemos
hacen
hacer
haces
hago
incluso
intenta
intentais
intentamos
intentan
intentar
intentas
intento
ir
la
largo
las
lo
los
mientras
mio
modo
muchos
muy
nos
nosotros
otro
para
pero
podeis
podemos
poder
podria
podriais
podriamos
podrian
podrias
por
por qu
porque
primero
puede
pueden
puedo
quien
sabe
sabeis
sabemos
saben
saber
sabes
ser
si
siendo
sin
sobre
sois
solamente
solo
somos
soy
su
sus
tambin
teneis
tenemos
tener
tengo
tiempo
tiene
tienen
todo
trabaja
trabajais
trabajamos
trabajan
trabajar
trabajas
trabajo
tras
tuyo
ultimo
un
una
unas
uno
unos
usa
usais
usamos
usan
usar
usas
uso
va
vais
valor
vamos
van
vaya
verdad
verdadera
verdadero
vosotras
vosotros
voy
yo' findTokens: String crlf
]! !

Object subclass: #OIndexer
	instanceVariableNames: 'mainIndex indexName stopWords status w stop nodesSet snapshotter numberOfWords deletedIds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

OIndexer class
	instanceVariableNames: 'thesaurus'!

OIndexer class
	instanceVariableNames: 'thesaurus'!

OIndexer subclass: #OIFolderIndexer
	instanceVariableNames: 'arrayOfProcesses np monitor processCleaner folderIndexer monitorIndexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIFolderIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/1/2013 20:21'!
name: aDirName
| a |
a:= super name:aDirName index: (OIFsReverseNode on:( FileDirectory default pathName, FileDirectory pathNameDelimiter asString), aDirName asString).
^a! !

!OIFolderIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/1/2013 20:18'!
new
| a |
a:= super new.
a initialize:nil.
^a! !

!OIFolderIndexer methodsFor: 'indexing' stamp: 'JesusMari 6/23/2013 10:36'!
indexeFolder:aFolderPath
Transcript show:'Start Indexing at ', Time now asString.
self startSnapshotter.
[
	monitorIndexer critical:[
	[self isTerminated] whileFalse:[(Delay forMilliseconds: 600) wait ].
	folderIndexer:=[
		stop:=false.
		self startProcessCleaner.
		self rindexeFolder:aFolderPath.
		self stop.
		Transcript show:'Stopping Indexing at ', Time now asString.] forkNamed: 'indexer-', aFolderPath].
] forkNamed: 'indexer-folder'.
 


! !

!OIFolderIndexer methodsFor: 'initialize-release' stamp: 'JesusMari 5/31/2013 18:04'!
initialize: aName
super initialize:aName.
"np: number of indexing processes running"
np:=0.
"array of indexing processes running "
arrayOfProcesses:= Array new:self maxProcesses.
monitor:= Monitor new.
monitorIndexer:= Monitor new.
self loadDeletedIds

! !

!OIFolderIndexer methodsFor: 'indexing' stamp: 'JesusMari 5/20/2013 15:03'!
isTerminated
folderIndexer ifNil:[^true].
processCleaner  ifNil:[^true].
^ folderIndexer isTerminated and:[processCleaner isTerminated]! !

!OIFolderIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 12:52'!
loadDeletedIds
|stream result collection jobject |

stream:=  (self mainIndex fd fileNamed: 'deletedIds.json').
stream ifNil:[^self].
[
	[stream atEnd] whileFalse:[
		deletedIds:= OIDeletedResults new fromJson: (Json readFrom:stream).
		]
]
ensure:[stream close].
! !

!OIFolderIndexer methodsFor: 'private' stamp: 'JesusMari 5/24/2013 09:51'!
maxProcesses
^3! !

!OIFolderIndexer methodsFor: 'private' stamp: 'JesusMari 5/24/2013 17:33'!
rindexeFolder:aFolderPath 
| dir a elements aStream   |

dir:= FileDirectory on: aFolderPath .
elements :=dir entries.


elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
			self isStopping ifFalse:[self rindexeFolder: (entry fullName)] 
	]
	ifFalse:[
		self isStopping ifFalse:[
		[np>=arrayOfProcesses size] whileTrue:[(Delay forMilliseconds: 1000) wait.].
		monitor critical:[
			arrayOfProcesses at: np+1 put: 
			([[aStream := entry readStream.
			self indexeMessages: #(#contents) 
				byId: (entry fullName)  
				from: aStream] 
			ensure:[
				aStream close]]  forkNamed: 'indexer-', entry fullName).
		np:=np+1]].
	]
].




	

! !

!OIFolderIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/31/2013 17:55'!
saveDeletedIds
|subdirs sd stream|
	sd:=self mainIndex fd.

	stream:=sd fileNamed: ('deletedIds.json').
		[Json render:self deletedIds on:stream ] ensure: [stream close].
! !

!OIFolderIndexer methodsFor: 'private' stamp: 'JesusMari 5/24/2013 13:50'!
startProcessCleaner
| n |
processCleaner ifNotNil:[
	processCleaner isTerminated ifFalse:[
		^self
		]
	].
processCleaner:=[
	"wait for the first process"
	(Delay forMilliseconds: 500) wait.
	[self isStopping and:[np=0 and:[folderIndexer isTerminated]]] whileFalse:[
				monitor critical:[	
						(1 to:arrayOfProcesses size) do:[:aPn|
							(arrayOfProcesses at:aPn) isTerminated ifTrue:[
							np>0 ifTrue:[
								arrayOfProcesses at:aPn put: (arrayOfProcesses at: (np)).
								np:=np-1].
							].
						]
				].
		"	(Delay forMilliseconds: 5000) wait."
			].
]forkAt: Processor userBackgroundPriority named: 'indexer-cleaner'.! !

OIndexer subclass: #OIMessageIndexer
	instanceVariableNames: 'arrayOfProcesses np monitor processCleaner folderIndexer monitorIndexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core'!

!OIMessageIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:01'!
name: aDirName
| a |
a:= super name:aDirName index: (OIFsReverseNode on:( FileDirectory default pathName, FileDirectory pathNameDelimiter asString), aDirName asString).
^a! !

!OIMessageIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:01'!
new
| a |
a:= super new.
a initialize:nil.
^a! !

!OIMessageIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/20/2013 22:05'!
indexeMessages:aMessageCollection by:anIndexField fromACollection:aCollection
"build an index of words from reading a message from an Object Collection"


self startSnapshotter.
[
	monitorIndexer critical:[
	[self isTerminated] whileFalse:[(Delay forMilliseconds: 600) wait ].
	folderIndexer:=[
		stop:=false.
		self startProcessCleaner.
		self rindexeMessages:aMessageCollection by:anIndexField fromACollection:aCollection.
		self stop] forkNamed: 'indexer-collection', aCollection asString ].
] forkNamed: 'indexer-folder'.! !

!OIMessageIndexer methodsFor: 'initialize-release' stamp: 'JesusMari 6/18/2013 13:01'!
initialize: aName
super initialize:aName.
"np: number of indexing processes running"
np:=0.
"array of indexing processes running "
arrayOfProcesses:= Array new:self maxProcesses.
monitor:= Monitor new.
monitorIndexer:= Monitor new.
self loadDeletedIds

! !

!OIMessageIndexer methodsFor: 'indexing' stamp: 'JesusMari 6/18/2013 13:01'!
isTerminated
folderIndexer ifNil:[^true].
processCleaner  ifNil:[^true].
^ folderIndexer isTerminated and:[processCleaner isTerminated]! !

!OIMessageIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:01'!
loadDeletedIds
|stream result collection jobject |

stream:=  (self mainIndex fd fileNamed: 'deletedIds.json').
stream ifNil:[^self].
[
	[stream atEnd] whileFalse:[
		deletedIds:= OIDeletedResults new fromJson: (Json readFrom:stream).
		]
]
ensure:[stream close].
! !

!OIMessageIndexer methodsFor: 'private' stamp: 'JesusMari 6/18/2013 13:01'!
maxProcesses
^3! !

!OIMessageIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:18'!
rindexeMessages:aMessageCollection by:anIndexField fromACollection:aCollection

aCollection do:[:item|
	self isStopping ifFalse:[
		[np>=arrayOfProcesses size] whileTrue:[(Delay forMilliseconds: 1000) wait.].
		monitor critical:[
			arrayOfProcesses at: np+1 put: 
			([
				self indexeMessages: aMessageCollection
					by: anIndexField  
					from: item]  forkNamed: 'indexer-', item asString).
		np:=np+1]
	].
]



	

! !

!OIMessageIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:01'!
saveDeletedIds
|subdirs sd stream|
	sd:=self mainIndex fd.

	stream:=sd fileNamed: ('deletedIds.json').
		[Json render:self deletedIds on:stream ] ensure: [stream close].
! !

!OIMessageIndexer methodsFor: 'private' stamp: 'JesusMari 6/18/2013 13:01'!
startProcessCleaner
| n |
processCleaner ifNotNil:[
	processCleaner isTerminated ifFalse:[
		^self
		]
	].
processCleaner:=[
	"wait for the first process"
	(Delay forMilliseconds: 500) wait.
	[self isStopping and:[np=0 and:[folderIndexer isTerminated]]] whileFalse:[
				monitor critical:[	
						(1 to:arrayOfProcesses size) do:[:aPn|
							(arrayOfProcesses at:aPn) isTerminated ifTrue:[
							np>0 ifTrue:[
								arrayOfProcesses at:aPn put: (arrayOfProcesses at: (np)).
								np:=np-1].
							].
						]
				].
		"	(Delay forMilliseconds: 5000) wait."
			].
]forkAt: Processor userBackgroundPriority named: 'indexer-cleaner'.! !

!OIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/1/2013 20:16'!
name: aDirName index:anOIReverseNode
| a |
a:= super new.
self thesaurus.
a mainIndex:anOIReverseNode.
a initialize:aDirName.
^a! !

!OIndexer class methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2013 13:34'!
reset
thesaurus:=nil! !

!OIndexer class methodsFor: 'accessing' stamp: 'JesusMari 6/1/2013 20:18'!
thesaurus
	^ thesaurus ifNil:[thesaurus:=OIThesaurus on:'thesaurus\mobythes.aur'].! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 5/3/2013 23:20'!
calculateDiagonal: anArrayOfVectors
|result mult max|
result:=0.0.
mult:=0.0.
max:=0.0.

anArrayOfVectors do:[:r|
	r> mult ifTrue:[mult:=r].
	result:= (r*r) + result.
	].

(mult = 0) ifTrue:[^0].
1 to: anArrayOfVectors size do:[:a|
	max:=max + ((mult - a +1)*(mult - a +1))
	].

^ (result/ max) sqrt   ! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 5/6/2013 12:52'!
calculateDistance: aDic

| matrix max positions |
matrix:= Matrix new:aDic size.
positions:=Array new:aDic size.

(1 to: matrix rowCount by:1) do:[:i|
	(1to:matrix columnCount ) do:[:j|
		matrix at:i at:j put: ((aDic values at:j) at:i ifAbsent:(OIResult id:nil pos:0)) pos.
	]
].

max:=self generateTreeAt:1 at:1  v:positions  m: matrix.
^max.
! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 5/19/2013 02:42'!
clean: aWord
aWord size< self minSize ifTrue:[^ Character space asString].
^(aWord collect:[:c | 
	
	(c isLetter or: [c = Character space or: [c isDigit ] ]) 
	ifTrue:[c] 
	ifFalse:[
		(c=$' or:[c=$]) ifTrue:[$%]
		ifFalse:[Character space]]] ) asLowercase ! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 6/18/2013 11:15'!
deleteId:anId
deletedIds add: (OIDeletedResult id:anId)! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/31/2013 10:31'!
deletedIds
	^ deletedIds! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 5/2/2013 10:01'!
delimiters
^ Character space! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 1/7/2013 09:18'!
findCandidatesOn:treeNode
^ self findCandidatesOn:treeNode candidates: OrderedCollection new
! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 6/23/2013 21:58'!
findCandidatesOn:treeNode candidates: c
treeNode reload.
treeNode identifiers isEmpty
	ifTrue:[
		treeNode dictionary values do:[:aTreeNode|
		self findCandidatesOn: aTreeNode candidates: c]
	 ]
	ifFalse: [
		c addAll: (treeNode identifiers reject:[:each| deletedIds includes: each]).
		 ].
				
	^ c.


! !

!OIndexer methodsFor: 'public-querying' stamp: 'JesusMari 5/14/2013 20:26'!
findPhrase:aPhrase 
^self findPhrase:aPhrase minTarget:1! !

!OIndexer methodsFor: 'public-querying' stamp: 'JesusMari 9/3/2013 17:57'!
findPhrase:aPhrase minTarget:aFloat
|wordCollection results finalResult aCol lastId lastPos dif counter lastValue synonymous |

finalResult:=Dictionary new.
wordCollection:= ((self clean:(aPhrase asString)) findTokens: self delimiters) select:[:a| a size> self minSize].
results:=Dictionary new.

wordCollection do:[:aWord|
	synonymous:=self class thesaurus getSynonymousOf: aWord.
	aCol:=(self findWord:synonymous minTraget: 1).
	aCol do:[: aRes| 
			((results at: aRes id ifAbsentPut:[Dictionary new]) 
				at: aWord ifAbsentPut: [OrderedCollection new]) add: aRes.	
	]
].
"score by number of words- 80%"
results keys do:[:aKey|
	(results at:aKey) at:'SCORE' put:(((results at:aKey) size / wordCollection size)* (self calculateDistance:(results at:aKey)))
	].

^results

! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 5/31/2013 10:32'!
findWord:aWord
^self findWord:aWord minTraget:1! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 5/30/2013 10:57'!
findWord:aWord minTraget:aFloat
| treeNode root i candidates syllabes target |
target:=1.
(aFloat <1 ) ifTrue:[
	target:=aFloat.
].
i:=0.
syllabes:= (((self getPathTo: aWord asLowercase) contents) findTokens: FileDirectory pathNameDelimiter).

(aWord size > self minSize) ifTrue:[
	treeNode:=mainIndex.
	root:= mainIndex at:(syllabes at:1)  ifAbsent:[^ OrderedCollection new].
	root reload.
	syllabes do: [:aSyllabe|
		 treeNode:=treeNode at: aSyllabe ifAbsent:[ 
			(( i asFloat / (aWord size) asFloat) >= target) 
			ifTrue:[
					candidates:=self findCandidatesOn:treeNode.
					"return the closest results"
					^ candidates]
			ifFalse:[
				^OrderedCollection new]
				
			].
		i:= i+ aSyllabe size.
	].
	"return the closest results"
	candidates:=self findCandidatesOn:treeNode.
	^candidates
	].
^OrderedCollection new
! !

!OIndexer methodsFor: 'private-querying' stamp: 'JesusMari 5/3/2013 23:22'!
generateTreeAt:i at:j v:aVector m:aMatrix
"initial values i,j=1 vector[1,1,1..n]"
|p aV  r1 r2 r3|
r1:=r2:=r3:=0.
 
		(i<=aVector size) 
			ifTrue:[
				(j<= aVector size)
					ifTrue:[
						aVector at: j put:(aMatrix at:i at:j). 
						r1:=self generateTreeAt: 1 at:(j+1) v:aVector m:aMatrix.
						r2:=self generateTreeAt: (i+1) at: j v:aVector m:aMatrix.
						]
					ifFalse:[
						(self calculateDiagonal:aVector)> r3 ifTrue:[r3:=self calculateDiagonal:aVector].	
					]
				].

(r1 >= r2) 
ifTrue:[
	 (r1>= r3) 
		ifTrue:[^r1]
		ifFalse:[^r3]]
ifFalse:[
	 (r2>= r3) 
		ifTrue:[^r2]
		ifFalse:[^r3]]
			! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 5/30/2013 11:37'!
getPathTo:aWord
"returns the pathname to a word"
|i strm|

strm:= ReadWriteStream on:String new.
i:= 1.
(((aWord at:1) = $a) and:[aWord size>=3]) ifTrue:[
	strm nextPut:(aWord at:1).
	strm nextPut:(aWord at:2).
	strm nextPut:(aWord at:3).
	strm nextPut:FileDirectory pathNameDelimiter.
	i:=4.
	].
[i<=aWord size]  whileTrue:[
		strm nextPut:(aWord at:i).
		((i \\ 2) = 0 )ifTrue:[strm nextPut:FileDirectory pathNameDelimiter].
		i:=i+1
		].
^strm! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/8/2013 01:20'!
indexName
	^ indexName ifNil:[self identityHash asString] ifNotNil:[indexName].! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 1/8/2013 01:19'!
indexName: anObject
	indexName := anObject! !

!OIndexer methodsFor: 'private-indexing' stamp: 'JesusMari 6/18/2013 10:16'!
indexeAWord:aWord by:anIndexField pos:anInteger
| treeNode root rn strm aSynonimous|
aSynonimous:=self class thesaurus getSynonymousOf: aWord.

((aSynonimous size > self minSize) and:[(self stopWords includes:aSynonimous ) not])ifTrue:[
	treeNode:=mainIndex.
	strm:= self getPathTo: aSynonimous .
	treeNode:= self mainIndex  nodeAt: strm contents.
	treeNode addIdentifier:anIndexField atPos:anInteger.
	^treeNode firstNode.
	].
"nil if not indexed"
^nil! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 5/6/2013 10:15'!
indexeMessages:aMessageCollection by:anIndexField from:anItem
"build an index of words from reading a message from an Object Collection"
| id |

[id:= (anItem perform: anIndexField asSymbol) asString] on: Error do:[^self].
self indexeMessages:aMessageCollection byId: id from:anItem.
! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 5/15/2013 09:05'!
indexeMessages:aMessageCollection by:anIndexField fromACollection:aCollection
"build an index of words from reading a message from an Object Collection"


aCollection do:[:anItem|
	self indexeMessages:aMessageCollection by:anIndexField from:anItem.
	self isStopping ifTrue:[^self]
].
! !

!OIndexer methodsFor: 'public-indexing' stamp: 'JesusMari 6/23/2013 10:38'!
indexeMessages:aMessageCollection byId:anIndex from:anItem
"build an index of words from reading a message from an Object Collection"
| content wordCollection  id pos n |
pos:=1.
id:= anIndex.

"Transcript show: Time millisecondClockValue  asString, '.-removing old indexes',String crlf.
self removeIndexesFrom:id."

[aMessageCollection do:[:aMessage|
	[content:= anItem perform: aMessage asSymbol] on: Error do:[content:=nil].	
	
	content ifNotNil:[
		pos:=0.
		status:='cleanning and tokenize'.
		wordCollection:= (self clean:(content asString)) findTokens: self delimiters.
		wordCollection do:[:aWord| 
			pos:=pos+1.
			status:= (pos / wordCollection size) asFloat.
			w:=aWord.
			n:=
			(self indexeAWord:  (aWord)
							by: id 
							pos: pos) .
			n ifNotNil:[nodesSet add: n]. 
			].
		].
	]
] ensure:[	
"	self reverseIndex purge:id.
	self reverseIndex snapshot: id."
	self
	].


! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 5/2/2013 09:55'!
initStopWords
^#('a%s', 'able', 'about', 'above', 'according', 'accordingly', 'across', 'actually', 'after', 'afterwards', 'again', 'against', 'ain%t', 'all', 'allow', 'allows', 'almost', 'alone', 'along', 'already', 'also', 'although', 'always', 'am', 'among', 'amongst', 'an', 'and', 'another', 'any', 'anybody', 'anyhow', 'anyone', 'anything', 'anyway', 'anyways', 'anywhere', 'apart', 'appear', 'appreciate', 'appropriate', 'are', 'aren%t', 'around', 'as', 'aside', 'ask', 'asking', 'associated', 'at', 'available', 'away', 'awfully', 'be', 'became', 'because', 'become', 'becomes', 'becoming', 'been', 'before', 'beforehand', 'behind', 'being', 'believe', 'below', 'beside', 'besides', 'best', 'better', 'between', 'beyond', 'both', 'brief', 'but', 'by', 'c%mon', 'c%s', 'came', 'can', 'can%t', 'cannot', 'cant', 'cause', 'causes', 'certain', 'certainly', 'changes', 'clearly', 'co', 'com', 'come', 'comes', 'concerning', 'consequently', 'consider', 'considering', 'contain', 'containing', 'contains', 'corresponding', 'could', 'couldn%t', 'course', 'currently', 'definitely', 'described', 'despite', 'did', 'didn%t', 'different', 'do', 'does', 'doesn%t', 'doing', 'don%t', 'done', 'down', 'downwards', 'during', 'each', 'edu', 'eg', 'eight', 'either', 'else', 'elsewhere', 'enough', 'entirely', 'especially', 'et', 'etc', 'even', 'ever', 'every', 'everybody', 'everyone', 'everything', 'everywhere', 'ex', 'exactly', 'example', 'except', 'far', 'few', 'fifth', 'first', 'five', 'followed', 'following', 'follows', 'for', 'former', 'formerly', 'forth', 'four', 'from', 'further', 'furthermore', 'get', 'gets', 'getting', 'given', 'gives', 'go', 'goes', 'going', 'gone', 'got', 'gotten', 'greetings', 'had', 'hadn%t', 'happens', 'hardly', 'has', 'hasn%t', 'have', 'haven%t', 'having', 'he', 'he%s', 'hello', 'help', 'hence', 'her', 'here', 'here%s', 'hereafter', 'hereby', 'herein', 'hereupon', 'hers', 'herself', 'hi', 'him', 'himself', 'his', 'hither', 'hopefully', 'how', 'howbeit', 'however', 'i%d', 'i%ll', 'i%m', 'i%ve', 'ie', 'if', 'ignored', 'immediate', 'in', 'inasmuch', 'inc', 'indeed', 'indicate', 'indicated', 'indicates', 'inner', 'insofar', 'instead', 'into', 'inward', 'is', 'isn%t', 'it', 'it%d', 'it%ll', 'it%s', 'its', 'itself', 'just', 'keep', 'keeps', 'kept', 'know', 'knows', 'known', 'last', 'lately', 'later', 'latter', 'latterly', 'least', 'less', 'lest', 'let', 'let%s', 'like', 'liked', 'likely', 'little', 'look', 'looking', 'looks', 'ltd', 'mainly', 'many', 'may', 'maybe', 'me', 'mean', 'meanwhile', 'merely', 'might', 'more', 'moreover', 'most', 'mostly', 'much', 'must', 'my', 'myself', 'name', 'namely', 'nd', 'near', 'nearly', 'necessary', 'need', 'needs', 'neither', 'never', 'nevertheless', 'new', 'next', 'nine', 'no', 'nobody', 'non', 'none', 'noone', 'nor', 'normally', 'not', 'nothing', 'novel', 'now', 'nowhere', 'obviously', 'of', 'off', 'often', 'oh', 'ok', 'okay', 'old', 'on', 'once', 'one', 'ones', 'only', 'onto', 'or', 'other', 'others', 'otherwise', 'ought', 'our', 'ours', 'ourselves', 'out', 'outside', 'over', 'overall', 'own', 'particular', 'particularly', 'per', 'perhaps', 'placed', 'please', 'plus', 'possible', 'presumably', 'probably', 'provides', 'que', 'quite', 'qv', 'rather', 'rd', 're', 'really', 'reasonably', 'regarding', 'regardless', 'regards', 'relatively', 'respectively', 'right', 'said', 'same', 'saw', 'say', 'saying', 'says', 'second', 'secondly', 'see', 'seeing', 'seem', 'seemed', 'seeming', 'seems', 'seen', 'self', 'selves', 'sensible', 'sent', 'serious', 'seriously', 'seven', 'several', 'shall', 'she', 'should', 'shouldn%t', 'since', 'six', 'so', 'some', 'somebody', 'somehow', 'someone', 'something', 'sometime', 'sometimes', 'somewhat', 'somewhere', 'soon', 'sorry', 'specified', 'specify', 'specifying', 'still', 'sub', 'such', 'sup', 'sure', 't%s', 'take', 'taken', 'tell', 'tends', 'th', 'than', 'thank', 'thanks', 'thanx', 'that', 'that%s', 'thats', 'the', 'their', 'theirs', 'them', 'themselves', 'then', 'thence', 'there', 'there%s', 'thereafter', 'thereby', 'therefore', 'therein', 'theres', 'thereupon', 'these', 'they', 'they%d', 'they%ll', 'they%re', 'they%ve', 'think', 'third', 'this', 'thorough', 'thoroughly', 'those', 'though', 'three', 'through', 'throughout', 'thru', 'thus', 'to', 'together', 'too', 'took', 'toward', 'towards', 'tried', 'tries', 'truly', 'try', 'trying', 'twice', 'two', 'un', 'under', 'unfortunately', 'unless', 'unlikely', 'until', 'unto', 'up', 'upon', 'us', 'use', 'used', 'useful', 'uses', 'using', 'usually', 'value', 'various', 'very', 'via', 'viz', 'vs', 'want', 'wants', 'was', 'wasn%t', 'way', 'we', 'we%d', 'we%ll', 'we%re', 'we%ve', 'welcome', 'well', 'went', 'were', 'weren%t', 'what', 'what%s', 'whatever', 'when', 'whence', 'whenever', 'where', 'where%s', 'whereafter', 'whereas', 'whereby', 'wherein', 'whereupon', 'wherever', 'whether', 'which', 'while', 'whither', 'who', 'who%s', 'whoever', 'whole', 'whom', 'whose', 'why', 'will', 'willing', 'wish', 'with', 'within', 'without', 'won%t', 'wonder', 'would', 'would', 'wouldn%t', 'yes', 'yet', 'you', 'you%d', 'you%ll', 'you%re', 'you%ve', 'your', 'yours', 'yourself', 'yourselves', 'zero')! !

!OIndexer methodsFor: 'initialize-release' stamp: 'JesusMari 6/18/2013 10:47'!
initialize:aName
super initialize.
stop:=false.
"modified nodes will be stored in nodeSet by indexeMessage method"
nodesSet:=IdentitySet new. 
aName ifNotNil:[self indexName: aName].
stopWords:=OrderedCollection newFrom:self initStopWords.
"snapShotter processes reads nodeSet and takes out elements to store them into..."
deletedIds:=OIDeletedResults new.
"self startSnapshotter."

 
! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:06'!
isStopping
^stop! !

!OIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/31/2013 18:11'!
loadDeletedIds
self subclassResponsibility ! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 12/26/2012 16:49'!
mainIndex
^mainIndex! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 6/1/2013 20:10'!
mainIndex:anOIReverseNode
mainIndex:=anOIReverseNode! !

!OIndexer methodsFor: 'private' stamp: 'JesusMari 12/26/2012 23:48'!
minSize
^3! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/18/2013 19:22'!
nodesSet
	^ nodesSet! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/18/2013 19:22'!
nodesSet: anObject
	nodesSet := anObject! !

!OIndexer methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/31/2013 18:11'!
saveDeletedIds
self subclassResponsibility ! !

!OIndexer methodsFor: 'initialize-release' stamp: 'JesusMari 5/20/2013 15:58'!
startSnapshotter
| n |
snapshotter ifNotNil:[
	snapshotter isTerminated ifFalse:[
		^self
		]
	].

snapshotter:=[
		[self isStopping and: [self nodesSet isEmpty]] whileFalse:[
			[self nodesSet size>0] whileTrue:[
				n:=self nodesSet remove: self nodesSet anyOne.
				n snapshot.
				]
		]
	]forkAt:30 named: 'indexer-snapshooter'
! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/15/2013 09:07'!
stop
stop:=true! !

!OIndexer methodsFor: 'accessing' stamp: 'JesusMari 5/2/2013 09:40'!
stopWords
^stopWords! !

Object subclass: #OItest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectIndexer-Core-Tests'!

!OItest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:38'!
id
^'jquerycouch'! !

!OItest methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/26/2013 11:33'!
jquerycouchJs 
^'// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy of
// the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations under
// the License.

/**
 * @namespace
 * $.couch is used to communicate with a CouchDB server, the server methods can
 * be called directly without creating an instance. Typically all methods are
 * passed an <code>options</code> object which defines a success callback which
 * is called with the data returned from the http request to CouchDB, you can
 * find the other settings that can be used in the <code>options</code> object
 * from <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
 * jQuery.ajax settings</a>
 * <pre><code>$.couch.activeTasks({
 *   success: function (data) {
 *     console.log(data);
 *   }
 * });</code></pre>
 * Outputs (for example):
 * <pre><code>[
 *  {
 *   "pid" : "<0.11599.0>",
 *   "status" : "Copied 0 of 18369 changes (0%)",
 *   "task" : "recipes",
 *   "type" : "Database Compaction"
 *  }
 *]</code></pre>
 */
(function($) {

  $.couch = $.couch || {};
  /** @lends $.couch */

  /**
   * @private
   */
  function encodeDocId(docID) {
    var parts = docID.split("/");
    if (parts[0] == "_design") {
      parts.shift();
      return "_design/" + encodeURIComponent(parts.join(''/''));
    }
    return encodeURIComponent(docID);
  }

  /**
   * @private
   */

  var uuidCache = [];

  $.extend($.couch, {
    urlPrefix: '''',

    /**
     * You can obtain a list of active tasks by using the /_active_tasks URL.
     * The result is a JSON array of the currently running tasks, with each task
     * being described with a single object.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_active_tasks</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    activeTasks: function(options) {
      ajax(
        {url: this.urlPrefix + "/_active_tasks"},
        options,
        "Active task status could not be retrieved"
      );
    },

    /**
     * Returns a list of all the databases in the CouchDB instance
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_active-task
     * s_get">docs for /_all_dbs</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/jQuery.ajax
     * /#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    allDbs: function(options) {
      ajax(
        {url: this.urlPrefix + "/_all_dbs"},
        options,
        "An error occurred retrieving the list of all databases"
      );
    },

    /**
     * View and edit the CouchDB configuration, called with just the options
     * parameter the entire config is returned, you can be more specific by
     * passing the section and option parameters, if you specify a value that
     * value will be stored in the configuration.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-config.html#couchbase-api-config_config
     * -section-key_put">docs for /_config</a>
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     * @param {String} [section] the section of the config
     * @param {String} [option] the particular config option
     * @param {String} [value] value to be set
     */
    config: function(options, section, option, value) {
      var req = {url: this.urlPrefix + "/_config/"};
      if (section) {
        req.url += encodeURIComponent(section) + "/";
        if (option) {
          req.url += encodeURIComponent(option);
        }
      }
      if (value === null) {
        req.type = "DELETE";        
      } else if (value !!== undefined) {
        req.type = "PUT";
        req.data = toJSON(value);
        req.contentType = "application/json";
        req.processData = false
      }

      ajax(req, options,
        "An error occurred retrieving/updating the server configuration"
      );
    },
    
    /**
     * Returns the session information for the currently logged in user.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    session: function(options) {
      options = options || {};
      $.ajax({
        type: "GET", url: this.urlPrefix + "/_session",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw "An error occurred getting session info: " + resp.reason;
          }
        }
      });
    },

    /**
     * @private
     */
    userDb : function(callback) {
      $.couch.session({
        success : function(resp) {
          var userDb = $.couch.db(resp.info.authentication_db);
          callback(userDb);
        }
      });
    },

    /**
     * Create a new user on the CouchDB server, <code>user_doc</code> is an
     * object with a <code>name</code> field and other information you want
     * to store relating to that user, for example
     * <code>{"name": "daleharvey"}</code>
     * @param {Object} user_doc Users details
     * @param {String} password Users password
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
      * jQuery ajax settings</a>
     */
    signup: function(user_doc, password, options) {      
      options = options || {};
      user_doc.password = password;
      user_doc.roles =  user_doc.roles || [];
      user_doc.type =  user_doc.type = "user" || [];
      var user_prefix = "org.couchdb.user:";
      user_doc._id = user_doc._id || user_prefix + user_doc.name;

      $.couch.userDb(function(db) {
        db.saveDoc(user_doc, options);
      });
    },

    /**
     * Authenticate against CouchDB, the <code>options</code> parameter is
      *expected to have <code>name</code> and <code>password</code> fields.
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    login: function(options) {
      options = options || {};
      $.ajax({
        type: "POST", url: this.urlPrefix + "/_session", dataType: "json",
        data: {name: options.name, password: options.password},
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging in: '' + resp.reason;
          }
        }
      });
    },


    /**
     * Delete your current CouchDB user session
     * @param {ajaxSettings} options
     * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
     * jQuery ajax settings</a>
     */
    logout: function(options) {
      options = options || {};
      $.ajax({
        type: "DELETE", url: this.urlPrefix + "/_session", dataType: "json",
        username : "_", password : "_",
        beforeSend: function(xhr) {
            xhr.setRequestHeader(''Accept'', ''application/json'');
        },
        complete: function(req) {
          var resp = $.parseJSON(req.responseText);
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            throw ''An error occurred logging out: '' + resp.reason;
          }
        }
      });
    },

    /**
     * @namespace
     * $.couch.db is used to communicate with a specific CouchDB database
     * <pre><code>var $db = $.couch.db("mydatabase");
     *$db.allApps({
     *  success: function (data) {
     *    ... process data ...
     *  }
     *});
     * </code></pre>
     */
    db: function(name, db_opts) {
      db_opts = db_opts || {};
      var rawDocs = {};
      function maybeApplyVersion(doc) {
        if (doc._id && doc._rev && rawDocs[doc._id] &&
            rawDocs[doc._id].rev == doc._rev) {
          // todo: can we use commonjs require here?
          if (typeof Base64 == "undefined") {
            throw ''Base64 support not found.'';
          } else {
            doc._attachments = doc._attachments || {};
            doc._attachments["rev-"+doc._rev.split("-")[0]] = {
              content_type :"application/json",
              data : Base64.encode(rawDocs[doc._id].raw)
            };
            return true;
          }
        }
      };
      return /** @lends $.couch.db */{
        name: name,
        uri: this.urlPrefix + "/" + encodeURIComponent(name) + "/",

        /**
         * Request compaction of the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-compact_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options
         * <a href="http://api.jquery.com/jQuery.ajax/#jQuery-ajax-settings">
         * jQuery ajax settings</a>
         */
        compact: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact",
              data: "", processData: false
            },
            options,
            "The database could not be compacted"
          );
        },

        /**
         * Cleans up the cached view output on disk for a given view.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-view-cleanup_post">docs for /db/_compact</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        viewCleanup: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_view_cleanup",
              data: "", processData: false
            },
            options,
            "The views could not be cleaned up"
          );
        },

        /**
         * Compacts the view indexes associated with the specified design
         * document. You can use this in place of the full database compaction
         * if you know a specific set of view indexes have been affected by a
         * recent database change.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/upl
         * oads/all/documentation/couchbase-api-db.html#couchbase-api-db_db-
         * compact-design-doc_post">docs for /db/_compact/design-doc</a>
         * @param {String} groupname Name of design-doc to compact
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        compactView: function(groupname, options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact/" + groupname,
              data: "", processData: false
            },
            options,
            "The view could not be compacted"
          );
        },

        /**
         * Create a new database
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_put">docs for PUT /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        create: function(options) {
          $.extend(options, {successStatus: 201});
          ajax({
              type: "PUT", url: this.uri, contentType: "application/json",
              data: "", processData: false
            },
            options,
            "The database could not be created"
          );
        },

        /**
         * Deletes the specified database, and all the documents and
         * attachments contained within it.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db_delete">docs for DELETE /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        drop: function(options) {
          ajax(
            {type: "DELETE", url: this.uri},
            options,
            "The database could not be deleted"
          );
        },

        /**
         * Gets information about the specified database.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db_get">docs for GET /db/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        info: function(options) {
          ajax(
            {url: this.uri},
            options,
            "Database information could not be retrieved"
          );
        },

        /**
         * @namespace
         * $.couch.db.changes provides an API for subscribing to the changes
         * feed
         * <pre><code>var $changes = $.couch.db("mydatabase").changes();
         *$changes.onChange = function (data) {
         *    ... process data ...
         * }
         * $changes.stop();
         * </code></pre>
         */
        changes: function(since, options) {

          options = options || {};
          // set up the promise object within a closure for this handler
          var timeout = 100, db = this, active = true,
            listeners = [],
            promise = /** @lends $.couch.db.changes */ {
              /**
               * Add a listener callback
               * @see <a href="http://techzone.couchbase.com/sites/default/
               * files/uploads/all/documentation/couchbase-api-db.html#couch
               * base-api-db_db-changes_get">docs for /db/_changes</a>
               * @param {Function} fun Callback function to run when
               * notified of changes.
               */
            onChange : function(fun) {
              listeners.push(fun);
            },
              /**
               * Stop subscribing to the changes feed
               */
            stop : function() {
              active = false;
            }
          };
          // call each listener when there is a change
          function triggerListeners(resp) {
            $.each(listeners, function() {
              this(resp);
            });
          };
          // when there is a change, call any listeners, then check for
          // another change
          options.success = function(resp) {
            timeout = 100;
            if (active) {
              since = resp.last_seq;
              triggerListeners(resp);
              getChangesSince();
            };
          };
          options.error = function() {
            if (active) {
              setTimeout(getChangesSince, timeout);
              timeout = timeout * 2;
            }
          };
          // actually make the changes request
          function getChangesSince() {
            var opts = $.extend({heartbeat : 10 * 1000}, options, {
              feed : "longpoll",
              since : since
            });
            ajax(
              {url: db.uri + "_changes"+encodeOptions(opts)},
              options,
              "Error connecting to "+db.uri+"/_changes."
            );
          }
          // start the first request
          if (since) {
            getChangesSince();
          } else {
            db.info({
              success : function(info) {
                since = info.update_seq;
                getChangesSince();
              }
            });
          }
          return promise;
        },

        /**
         * Fetch all the docs in this db, you can specify an array of keys to
         * fetch by passing the <code>keys</code> field in the
         * <code>options</code>
         * parameter.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-all-docs_get">docs for /db/all_docs/</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDocs: function(options) {
          var type = "GET";
          var data = null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_all_docs" + encodeOptions(options)
            },
            options,
            "An error occurred retrieving a list of all documents"
          );
        },

        /**
         * Fetch all the design docs in this db
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allDesignDocs: function(options) {
          this.allDocs($.extend(
            {startkey:"_design", endkey:"_design0"}, options));
        },

        /**
         * Fetch all the design docs with an index.html, <code>options</code>
         * parameter expects an <code>eachApp</code> field which is a callback
         * called on each app found.
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        allApps: function(options) {
          options = options || {};
          var self = this;
          if (options.eachApp) {
            this.allDesignDocs({
              success: function(resp) {
                $.each(resp.rows, function() {
                  self.openDoc(this.id, {
                    success: function(ddoc) {
                      var index, appPath, appName = ddoc._id.split(''/'');
                      appName.shift();
                      appName = appName.join(''/'');
                      index = ddoc.couchapp && ddoc.couchapp.index;
                      if (index) {
                        appPath = ['''', name, ddoc._id, index].join(''/'');
                      } else if (ddoc._attachments &&
                                 ddoc._attachments["index.html"]) {
                        appPath = ['''', name, ddoc._id, "index.html"].join(''/'');
                      }
                      if (appPath) options.eachApp(appName, appPath, ddoc);
                    }
                  });
                });
              }
            });
          } else {
            throw ''Please provide an eachApp function for allApps()'';
          }
        },

        /**
         * Returns the specified doc from the specified db.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_get">docs for GET /db/doc</a>
         * @param {String} docId id of document to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        openDoc: function(docId, options, ajaxOptions) {
          options = options || {};
          if (db_opts.attachPrevRev || options.attachPrevRev) {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                rawDocs[doc._id] = {
                  rev : doc._rev,
                  raw : req.responseText
                };
              }
            });
          } else {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                if (doc["jquery.couch.attachPrevRev"]) {
                  rawDocs[doc._id] = {
                    rev : doc._rev,
                    raw : req.responseText
                  };
                }
              }
            });
          }
          ajax({url: this.uri + encodeDocId(docId) + encodeOptions(options)},
            options,
            "The document could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Create a new document in the specified database, using the supplied
         * JSON document structure. If the JSON structure includes the _id
         * field, then the document will be created with the specified document
         * ID. If the _id field is not specified, a new unique ID will be
         * generated.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db_post">docs for GET /db/doc</a>
         * @param {String} doc document to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        saveDoc: function(doc, options) {
          options = options || {};
          var db = this;
          var beforeSend = fullCommit(options);
          if (doc._id === undefined) {
            var method = "POST";
            var uri = this.uri;
          } else {
            var method = "PUT";
            var uri = this.uri + encodeDocId(doc._id);
          }
          var versioned = maybeApplyVersion(doc);
          $.ajax({
            type: method, url: uri + encodeOptions(options),
            contentType: "application/json",
            dataType: "json", data: toJSON(doc),
            beforeSend : beforeSend,
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 200 || req.status == 201 || req.status == 202) {
                doc._id = resp.id;
                doc._rev = resp.rev;
                if (versioned) {
                  db.openDoc(doc._id, {
                    attachPrevRev : true,
                    success : function(d) {
                      doc._attachments = d._attachments;
                      if (options.success) options.success(resp);
                    }
                  });
                } else {
                  if (options.success) options.success(resp);
                }
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be saved: " + resp.reason;
              }
            }
          });
        },

        /**
         * Save a list of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {Object[]} docs List of documents to save
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkSave: function(docs, options) {
          var beforeSend = fullCommit(options);
          $.extend(options, {successStatus: 201, beforeSend : beforeSend});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              contentType: "application/json", data: toJSON(docs)
            },
            options,
            "The documents could not be saved"
          );
        },

        /**
         * Deletes the specified document from the database. You must supply
         * the current (latest) revision and <code>id</code> of the document
         * to delete eg <code>removeDoc({_id:"mydoc", _rev: "1-2345"})</code>
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api
         * -dbdoc_db-doc_delete">docs for DELETE /db/doc</a>
         * @param {Object} doc Document to delete
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        removeDoc: function(doc, options) {
          ajax({
              type: "DELETE",
              url: this.uri +
                   encodeDocId(doc._id) +
                   encodeOptions({rev: doc._rev})
            },
            options,
            "The document could not be deleted"
          );
        },

        /**
         * Remove a set of documents
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db_
         * db-bulk-docs_post">docs for /db/_bulk_docs</a>
         * @param {String[]} docs List of document id''s to remove
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        bulkRemove: function(docs, options){
          docs.docs = $.each(
            docs.docs, function(i, doc){
              doc._deleted = true;
            }
          );
          $.extend(options, {successStatus: 201});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              data: toJSON(docs)
            },
            options,
            "The documents could not be deleted"
          );
        },

        /**
         * The COPY command (which is non-standard HTTP) copies an existing
         * document to a new or existing document.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-dbdoc.html#couchbase-api-
         * dbdoc_db-doc_copy">docs for COPY /db/doc</a>
         * @param {String[]} docId document id to copy
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        copyDoc: function(docId, options, ajaxOptions) {
          ajaxOptions = $.extend(ajaxOptions, {
            complete: function(req) {
              var resp = $.parseJSON(req.responseText);
              if (req.status == 201) {
                if (options.success) options.success(resp);
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                throw "The document could not be copied: " + resp.reason;
              }
            }
          });
          ajax({
              type: "COPY",
              url: this.uri + encodeDocId(docId)
            },
            options,
            "The document could not be copied",
            ajaxOptions
          );
        },

        /**
         * Creates (and executes) a temporary view based on the view function
         * supplied in the JSON request.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-db.html#couchbase-api-db
         * _db-temp-view_post">docs for /db/_temp_view</a>
         * @param {Function} mapFun Map function
         * @param {Function} reduceFun Reduce function
         * @param {Function} language Language the map / reduce funs are
         * implemented in
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        query: function(mapFun, reduceFun, language, options) {
          language = language || "javascript";
          if (typeof(mapFun) !!== "string") {
            mapFun = mapFun.toSource ? mapFun.toSource()
              : "(" + mapFun.toString() + ")";
          }
          var body = {language: language, map: mapFun};
          if (reduceFun !!= null) {
            if (typeof(reduceFun) !!== "string")
              reduceFun = reduceFun.toSource ? reduceFun.toSource()
                : "(" + reduceFun.toString() + ")";
            body.reduce = reduceFun;
          }
          ajax({
              type: "POST",
              url: this.uri + "_temp_view" + encodeOptions(options),
              contentType: "application/json", data: toJSON(body)
            },
            options,
            "An error occurred querying the database"
          );
        },

        /**
         * Fetch a _list view output, you can specify a list of
         * <code>keys</code> in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api
         * -design_db-design-designdoc-list-listname-viewname_get">
         * docs for /db/_design/design-doc/_list/l1/v1</a>
         * @param {String} list Listname in the form of ddoc/listname
         * @param {String} view View to run list against
         * @param {options} CouchDB <a href="http://wiki.apache.org/couchdb/
         * HTTP_view_API">View Options</a>
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        list: function(list, view, options, ajaxOptions) {
          var list = list.split(''/'');
          var options = options || {};
          var type = ''GET'';
          var data = null;
          if (options[''keys'']) {
            type = ''POST'';
            var keys = options[''keys''];
            delete options[''keys''];
            data = toJSON({''keys'': keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + ''_design/'' + list[0] +
                   ''/_list/'' + list[1] + ''/'' + view + encodeOptions(options)
              },
              ajaxOptions, ''An error occured accessing the list''
          );
        },

        /**
         * Executes the specified view-name from the specified design-doc
         * design document, you can specify a list of <code>keys</code>
         * in the options object to recieve only those keys.
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api-design.html#couchbase-api-
         * design_db-design-designdoc-view-viewname_get">docs for /db/
         * _design/design-doc/_list/l1/v1</a>
         * @param {String} name View to run list against
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        view: function(name, options) {
          var name = name.split(''/'');
          var options = options || {};
          var type = "GET";
          var data= null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_design/" + name[0] +
                   "/_view/" + name[1] + encodeOptions(options)
            },
            options, "An error occurred accessing the view"
          );
        },

        /**
         * Fetch an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        getDbProperty: function(propName, options, ajaxOptions) {
          ajax({url: this.uri + propName + encodeOptions(options)},
            options,
            "The property could not be retrieved",
            ajaxOptions
          );
        },

        /**
         * Set an arbitrary CouchDB database property
         * @see <a href="http://techzone.couchbase.com/sites/default/files/
         * uploads/all/documentation/couchbase-api.html">docs for /db/_prop</a>
         * @param {String} propName Propery name to fetch
         * @param {String} propValue Propery value to set
         * @param {ajaxSettings} options <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
         * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
         */
        setDbProperty: function(propName, propValue, options, ajaxOptions) {
          ajax({
            type: "PUT", 
            url: this.uri + propName + encodeOptions(options),
            data : JSON.stringify(propValue)
          },
            options,
            "The property could not be updated",
            ajaxOptions
          );
        }
      };
    },

    encodeDocId: encodeDocId, 

    /**
     * Accessing the root of a CouchDB instance returns meta information about
     * the instance. The response is a JSON structure containing information
     * about the server, including a welcome message and the version of the
     * server.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/uploads/
     * all/documentation/couchbase-api-misc.html#couchbase-api-misc_root_get">
     * docs for GET /</a>
     * @param {ajaxSettings} options <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     */
    info: function(options) {
      ajax(
        {url: this.urlPrefix + "/"},
        options,
        "Server information could not be retrieved"
      );
    },

    /**
     * Request, configure, or stop, a replication operation.
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_replicate_post">docs for POST /_replicate</a>
     * @param {String} source Path or url to source database
     * @param {String} target Path or url to target database
     * @param {ajaxSettings} ajaxOptions <a href="http://api.jquery.com/
     * jQuery.ajax/#jQuery-ajax-settings">jQuery ajax settings</a>
     * @param {Object} repOpts Additional replication options
     */
    replicate: function(source, target, ajaxOptions, repOpts) {
      repOpts = $.extend({source: source, target: target}, repOpts);
      if (repOpts.continuous && !!repOpts.cancel) {
        ajaxOptions.successStatus = 202;
      }
      ajax({
          type: "POST", url: this.urlPrefix + "/_replicate",
          data: JSON.stringify(repOpts),
          contentType: "application/json"
        },
        ajaxOptions,
        "Replication failed"
      );
    },

    /**
     * Fetch a new UUID
     * @see <a href="http://techzone.couchbase.com/sites/default/files/
     * uploads/all/documentation/couchbase-api-misc.html#couchbase-api-
     * misc_uuids_get">docs for /_uuids</a>
     * @param {Int} cacheNum Number of uuids to keep cached for future use
     */
    newUUID: function(cacheNum) {
      if (cacheNum === undefined) {
        cacheNum = 1;
      }
      if (!!uuidCache.length) {
        ajax({url: this.urlPrefix + "/_uuids", data: {count: cacheNum}, async:
              false}, {
            success: function(resp) {
              uuidCache = resp.uuids;
            }
          },
          "Failed to retrieve UUID batch."
        );
      }
      return uuidCache.shift();
    }
  });

  /**
   * @private
   */
  function ajax(obj, options, errorMessage, ajaxOptions) {

    var defaultAjaxOpts = {
      contentType: "application/json",
      headers:{"Accept": "application/json"}
    };

    options = $.extend({successStatus: 200}, options);
    ajaxOptions = $.extend(defaultAjaxOpts, ajaxOptions);
    errorMessage = errorMessage || "Unknown error";
    $.ajax($.extend($.extend({
      type: "GET", dataType: "json", cache : !!$.browser.msie,
      beforeSend: function(xhr){
        if(ajaxOptions && ajaxOptions.headers){
          for (var header in ajaxOptions.headers){
            xhr.setRequestHeader(header, ajaxOptions.headers[header]);
          }
        }
      },
      complete: function(req) {
        try {
          var resp = $.parseJSON(req.responseText);
        } catch(e) {
          if (options.error) {
            options.error(req.status, req, e);
          } else {
            throw errorMessage + '': '' + e;
          }
          return;
        }
        if (options.ajaxStart) {
          options.ajaxStart(resp);
        }
        if (req.status == options.successStatus) {
          if (options.beforeSuccess) options.beforeSuccess(req, resp);
          if (options.success) options.success(resp);
        } else if (options.error) {
          options.error(req.status, resp && resp.error ||
                        errorMessage, resp && resp.reason || "no response");
        } else {
          throw errorMessage + ": " + resp.reason;
        }
      }
    }, obj), ajaxOptions));
  }

  /**
   * @private
   */
  function fullCommit(options) {
    var options = options || {};
    if (typeof options.ensure_full_commit !!== "undefined") {
      var commit = options.ensure_full_commit;
      delete options.ensure_full_commit;
      return function(xhr) {
        xhr.setRequestHeader(''Accept'', ''application/json'');
        xhr.setRequestHeader("X-Couch-Full-Commit", commit.toString());
      };
    }
  };

  /**
   * @private
   */
  // Convert a options object to an url query string.
  // ex: {key:''value'',key2:''value2''} becomes ''?key="value"&key2="value2"''
  function encodeOptions(options) {
    var buf = [];
    if (typeof(options) === "object" && options !!== null) {
      for (var name in options) {
        if ($.inArray(name,
                      ["error", "success", "beforeSuccess", "ajaxStart"]) >= 0)
          continue;
        var value = options[name];
        if ($.inArray(name, ["key", "startkey", "endkey"]) >= 0) {
          value = toJSON(value);
        }
        buf.push(encodeURIComponent(name) + "=" + encodeURIComponent(value));
      }
    }
    return buf.length ? "?" + buf.join("&") : "";
  }

  /**
   * @private
   */
  function toJSON(obj) {
    return obj !!== null ? JSON.stringify(obj) : null;
  }

})(jQuery);
'! !
